#include <iostream>
#include <stdlib.h>
#include <fstream>
#include <string>
#include <sstream>


unsigned char rawWave[8] = {
	0x57, 0x41, 0x56, 0x45, 0x66, 0x6D, 0x74, 0x20, 
	} ;

unsigned char rawRiff[4] = {
	0x52, 0x49, 0x46, 0x46, 
	} ;

unsigned char rawSING[2] = {
	0x01, 0x00, 
	} ;

unsigned char rawDOUB[2] = {
	0x02, 0x00, 
	} ;

	
unsigned char rawStereo[8] = {
	0x04, 0x00, 0x10, 0x00, 0x64, 0x61, 0x74, 0x61, 
	} ;
	
unsigned char rawChannel[8] = {
	0x02, 0x00, 0x10, 0x00, 0x64, 0x61, 0x74, 0x61, 
	} ;	
	
unsigned char rawRates[6] = {
	0x10, 0x00, 0x00, 0x00, 0x01, 0x00, 
	} ;	


int main(int argc, char** argv) {
     std::string wvFileName=argv[1]; 
     
         FILE *vocRead;
         FILE *vocWrit;
         char one;
		 
         std::fstream checkvoc(wvFileName.c_str(), std::ios::in | 
		 std::ios::binary);
         checkvoc.seekg( 0, std::ios::end );
         long voc_size = checkvoc.tellg();
         checkvoc.seekg( 0, std::ios::beg );
         checkvoc.close();
		 
		 unsigned long header8 = voc_size-4;
		 unsigned long headr44 = voc_size-40;
		 unsigned long samprates;
		 unsigned long sndrate;
		 char bitsy;
		 char chans;
		 
		 vocRead = fopen(wvFileName.c_str(), "rb");
		 fseek(vocRead, 0x1E, SEEK_SET);
		 fread(&samprates, sizeof(unsigned long), 1, vocRead);
		 fread(&bitsy, sizeof(char), 1, vocRead);
		 fseek(vocRead, 0x23, SEEK_SET);
		 fread(&chans, sizeof(char), 1, vocRead);
		 
		 unsigned long vocsize2=voc_size;
		 
		 double vocsize= voc_size/(samprates*chans*bitsy/8);
		 //above not used atm. but is used for wav duration
		 //computation
        
         if(bitsy==16){
		 
		 if(chans==1){
		  sndrate=samprates*2; //if mono
		 }
		 
		 else{
		  sndrate=samprates*4; //if stereo
		 }
		 		 
		 fseek(vocRead, 0x28, SEEK_SET);
         vocWrit = fopen("clabs.wav", "wb+ab");
		 
		 
         fwrite(&rawRiff, sizeof(unsigned char), 4, vocWrit);
         fwrite(&header8, sizeof(unsigned long), 1, vocWrit);
         fwrite(&rawWave, sizeof(unsigned char), 8, vocWrit);
         fwrite(&rawRates, sizeof(unsigned char), 6, vocWrit);

          if(chans==1){
         fwrite(&rawSING, sizeof(unsigned char), 2, vocWrit);
          }
          
         else {
         fwrite(&rawDOUB, sizeof(unsigned char), 2, vocWrit);
          } 


         fwrite(&samprates, sizeof(unsigned long), 1, vocWrit);
         fwrite(&sndrate, sizeof(unsigned long), 1, vocWrit);
         
          if(chans==1){
         fwrite(&rawChannel, sizeof(unsigned char), 8, vocWrit);
          }
          
         else {
         fwrite(&rawStereo, sizeof(unsigned char), 8, vocWrit);
          } 
         	      	        	  
       	 fwrite(&headr44, sizeof(unsigned long), 1, vocWrit);
       	 
         int x = 0;
         
         while(x<voc_size-40){
         x++;
 
         fread(&one, sizeof (char), 1, vocRead);
         fwrite(&one, sizeof (char), 1, vocWrit);  		 
     	}
          fclose(vocWrit);
      }
      
        else {
         std::cout<<"incompatible wav_type (8bit)";
         std::cin.get();
        }
		fclose(vocRead); 		      
     
     
	return 0;
}     
